package maxflow;

import org.graphstream.graph.Edge;
import org.graphstream.graph.Graph;
import org.graphstream.graph.Node;
import org.graphstream.graph.implementations.SingleGraph;
import org.graphstream.stream.GraphParseException;

import java.io.IOException;

public class TestMaxFlow2 {

	public static void main(String[] args) throws IOException, GraphParseException {
		Graph g = new SingleGraph("test");
		g.addAttribute("ui.quality");
		g.addAttribute("ui.antialias");
		g.read("data/second_example.dgs");

		g.display();
		
		MaxFlow mf = new MaxFlow();
		mf.setCapacityAttribute("cap");
		mf.init(g);
		mf.setSource(g.getNode("s"));
		mf.setSink(g.getNode("t"));
		mf.compute();

		System.out.println(mf.getFlow());
		for (Edge e : g.getEachEdge()) {
			double flow = mf.getFlow(e);
			double cap = mf.getCapacity(e);
			e.addAttribute("ui.label", "" + flow + " / " + cap);
			if (cap == flow) e.addAttribute("ui.style", "fill-color: red;");
		}

		for( Node o : g.getEachNode() )
		{
			o.setAttribute("ui.label", o.getId());
		}

	}

}
